# htbb


## Description

Gradient-free discrete approximator and optimizer **HTBB** based on the hierarchical Tucker decomposition.


## Installation

1. Install [anaconda](https://www.anaconda.com) package manager with [python](https://www.python.org) (version 3.8);

2. Create a virtual environment:
    ```bash
    conda create --name htbb python=3.8 -y
    ```

3. Activate the environment:
    ```bash
    conda activate htbb
    ```

4. Install dependencies:
    ```bash
    pip install teneva_opti==0.5.3
    ```
    > When update `teneva_opti` version, please, do before: `pip uninstall teneva_opti -y`.

5. Optionally delete virtual environment at the end of the work:
    ```bash
    conda activate && conda remove --name htbb --all -y
    ```


## Computations

1. Run the approximation problems as:
    ```bash
    python run_func_appr.py
    ```
    > The results (for $d = 256$) will be in the `result_func_appr` folder. You can use the flag `--show` to only present the saved computation results. For the case of higher dimensions (`d = 512` and `d = 1024`) we saved the results in the `result_func_appr_d[d]` folder. To show the results, please, run the script like `python run_func_appr.py --show --fold result_func_appr_d512 --without_bs`.


2. Run the optimization problems as:
    ```bash
    python run_func_opti.py
    ```
    > The results will be in the `result_func_opti` folder. You can use the flags `--with_no_calc` to only present the saved computation results.